import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class TestMathFunction {
    private MathFunction myMath = new MathFunction();

    @Test
    protected void testBasicValuesFUNCTION1A(){
        assertEquals(6, myMath.leastCommonMultiple(2,3), "Nefunkční pro vstupy 2 a 3, NSN 6");
        assertEquals(600, myMath.leastCommonMultiple(100,120), "Nefunkční pro vstupy 100 a 120, NSN 600");

    }

    @Test
    protected void testBasicValuesFUNCTION1B(){
        assertEquals(5124, myMath.leastCommonMultiple(84,854), "Nefunkční pro vstupy 84 a 854, NSN 5124");
        assertEquals(96, myMath.leastCommonMultiple(32,48), "Nefunkční pro vstupy 32 a 48, NSN 96");
        assertEquals(825, myMath.leastCommonMultiple(55,75), "Nefunkční pro vstupy 55 a 75, NSN 825");
    }

    @Test
    protected void testBasicValuesFUNCTION2A(){
        assertEquals(60, myMath.leastCommonMultipleForThreeNumbers(15,10,20), "Nefunkční pro vstupy 10, 15 a 20, NSN 60");
        assertEquals(10200, myMath.leastCommonMultipleForThreeNumbers(100,120,170), "Nefunkční pro vstupy 100, 120 a 170, NSN 10 200");
    }
    @Test
    protected void testBasicValuesFUNCTION2B(){
        assertEquals(6213285, myMath.leastCommonMultipleForThreeNumbers(45, 1521, 2451), "Nefunkční pro vstupy 45, 1 521 a 2 451, NSN 6 213 285");
        assertEquals(125426840, myMath.leastCommonMultipleForThreeNumbers(1540, 3860, 8440), "Nefunkční pro vstupy 1 540, 3 860 a 8 440, NSN 125 426 840");
        assertEquals(4333308, myMath.leastCommonMultipleForThreeNumbers(653, 84, 79), "Nefunkční pro vstupy 653, 84 a 79, NSN 4 333 308");
    }

    @Test
    protected void testPrimeNumberA ()
    {
        boolean [] firstPrimeNumbers = new boolean [11];
        firstPrimeNumbers [0] = myMath.isPrimeNumber(2);
        firstPrimeNumbers [1] = myMath.isPrimeNumber(3);
        firstPrimeNumbers [2] = myMath.isPrimeNumber(4);
        firstPrimeNumbers [3] = myMath.isPrimeNumber(5);
        firstPrimeNumbers [4] = myMath.isPrimeNumber(6);
        firstPrimeNumbers [5] = myMath.isPrimeNumber(7);
        firstPrimeNumbers [6] = myMath.isPrimeNumber(8);
        firstPrimeNumbers [7] = myMath.isPrimeNumber(9);
        firstPrimeNumbers [8] = myMath.isPrimeNumber(10);
        firstPrimeNumbers [9] = myMath.isPrimeNumber(11);
        firstPrimeNumbers [10] = myMath.isPrimeNumber(12);
        assertArrayEquals(new boolean[]{true, true, false, true, false, true, false, false, false, true, false},firstPrimeNumbers,"Nefunční pro některé z čísel 2 - 11");
    }
    @Test
    protected void testPrimeNumberB ()
    {
        boolean [] firstPrimeNumbers = new boolean [11];
        firstPrimeNumbers [0] = myMath.isPrimeNumber(59);
        firstPrimeNumbers [1] = myMath.isPrimeNumber(61);
        firstPrimeNumbers [2] = myMath.isPrimeNumber(63);
        firstPrimeNumbers [3] = myMath.isPrimeNumber(65);
        firstPrimeNumbers [4] = myMath.isPrimeNumber(67);
        firstPrimeNumbers [5] = myMath.isPrimeNumber(69);
        firstPrimeNumbers [6] = myMath.isPrimeNumber(71);
        firstPrimeNumbers [7] = myMath.isPrimeNumber(73);
        firstPrimeNumbers [8] = myMath.isPrimeNumber(75);
        firstPrimeNumbers [9] = myMath.isPrimeNumber(77);
        firstPrimeNumbers [10] = myMath.isPrimeNumber(79);
        assertArrayEquals(new boolean[]{true, true, false, false, true, false, true, true, false, false, true},firstPrimeNumbers,"Nefunční pro některé z lichých čísel 59 - 79");
    }



}
